import java.lang.Math;

/**
 * FixedPoint.java
 *
 * @author Akio Miwa
 * @version 	@(#)FixedPoint.java	0.5, 10 Apl 2001
 */
/*
 Œ菬_̕\@
 l w
 2437    3      2437 * 10 * 10 * 10    = 2437000
 2437    2      2437 * 10 * 10         =  243700
 2437    1      2437 * 10              =   24370
 2437    0      2437 * 1               =    2437
 2437   -1      2437 * 0.1             =     243.7
 2437   -2      2437 * 0.1 * 0.1       =      24.37
 2437   -3      2437 * 0.1 * 0.1 * 0.1 =       2.437
 */


/////////////////////////
// FixedPoint NX
// Œ菬_
class FixedPoint {
/* fobOp̏RpCtO
final static boolean Debug = true;   // fobO
 */
final static boolean Debug = false;  // fobOς

final static int     PLUS  = 1;
final static int     MINUS = 0;

   int num;
   int point = 1;
   FixedPoint(int num, int point) {
      this.num   = num;
      this.point = point;
if (Debug) System.out.println("FP num / point = " + num + " / " + point);
   }
   int getNum()   { return num;   }
   int getPoint() { return point; }

   // longŎoB
   long getLong() {
      int index = 1;
      for (int i = 0; i < Math.abs(point); i++ ) index *= 10;
      return num / index;
   }

   // _ȉ̕\w肵āCɕϊB
   String getDouble(int place) {
      String       DiscardDecimals   = null;
      StringBuffer BelowDecimalPoint = new StringBuffer();
      long index = 1;
      int  sign  = 0;
      if (point >= 0)  sign = PLUS ;
      else             sign = MINUS;
      for (int i = 0; i < Math.abs(point); i++ ) index *= 10;
if (Debug) System.out.println("num / index = " + num + " / " + index);

      // w̕ɂď؂ւ
      switch (sign) {
         case PLUS  : DiscardDecimals   = ((long)num * index) + ".";
                      for (int i = 0; i < place; i++) {
                         BelowDecimalPoint.append("0");
                      }
                      break;
         case MINUS : DiscardDecimals   = ((long)num / index) + ".";
                      long d = Math.abs((long)num % index);
                      for (int i = 0; i < place; i++) {
                         if (index > 1) {
                            index /= 10;
                            BelowDecimalPoint.append(d / index);
                            d %= index;
                         } else {
                            BelowDecimalPoint.append("0");
                         }
if (Debug) System.out.println("DiscardDecimals . BelowDecimalPoint = " + DiscardDecimals + BelowDecimalPoint);
                      }
                      break;
      }
// if (Debug) System.out.println("DiscardDecimals . BelowDecimalPoint = " + DiscardDecimals + "." + BelowDecimalPoint);

      StringBuffer sb = new StringBuffer();
   // if (num >= 0) sb.append(" ");
   // else          sb.append("-");
      sb.append(DiscardDecimals);
//    sb.append(".");
      sb.append(BelowDecimalPoint);
      return sb.toString();
   }

   static int logarithm10(int n) {
       int l = 0;
       while (n > 10) {
          n /= 10;
          l++;
       }
       return l;
   }

   void setPoint(int point) { // _ʒu̕ύX
      int    a = this.point;
      int    b =      point;
      int diff = a - b;
      int  NewPoint = 1;
      int  OldPoint = 1;

      for (int i = 0; i < Math.abs(this.point); i++) OldPoint *=10;
      for (int i = 0; i < Math.abs(     point); i++) NewPoint *=10;
if (Debug) System.out.println("In  setPoint = " + this.num + ":" + this.point);
      if (0 != diff) { // _ʒuςȂꍇ́Â܂܂ƂB
         this.num   = num * NewPoint / OldPoint;
         this.point = point;
      }
if (Debug) System.out.println("Out setPoint = " + this.num + ":" + this.point);
   }

   // Œ菭_̊|Z	multiplication
   static FixedPoint mult(FixedPoint a, FixedPoint b) {
      long DiscardDecimals   = (long)a.num * (long)b.num;
      int  BelowDecimalPoint = a.point + b.point;
      if (DiscardDecimals >= 0) {
         // int ^̍ől傫ȏꍇ͏_ʒuύX,萔l  2147483647
         while (DiscardDecimals > (long)Integer.MAX_VALUE) {
            DiscardDecimals /= 10;
            BelowDecimalPoint++;
         }
      } else {
         // int ^̍ŏl菬ȏꍇ͏_ʒuύX,萔l  -2147483648
         while (DiscardDecimals < (long)Integer.MIN_VALUE) {
            DiscardDecimals /= 10;
            BelowDecimalPoint++;
         }
      }
      return new FixedPoint((int)DiscardDecimals,
                                   BelowDecimalPoint);
   }
   // Œ菭_̊Z	division
   static FixedPoint div(FixedPoint a, FixedPoint b) {
      long a_num   = (long)a.num;
      int  a_point = a.point;
      
      if (a_num >= 0) {
         while (a_num < ((long)Integer.MAX_VALUE * 1000000)) {
            a_num *= 10;
            a_point--;
         }
      } else {
         while (a_num > ((long)Integer.MIN_VALUE * 1000000)) {
            a_num *= 10;
            a_point--;
         }
      }

      long r_num   = a_num / (long)b.num;
      int  r_point = a_point - b.point;
if (Debug) System.out.println("r_num.r_point  = " + r_num + "." + r_point);
      if (r_num >= 0) {
         // int ^̍ől傫ȏꍇ͏_ʒuύX,萔l  2147483647
         while (r_num > (long)Integer.MAX_VALUE) {
            r_num /= 10;
            r_point++;
         }
      } else {
         // int ^̍ŏl菬ȏꍇ͏_ʒuύX,萔l  -2147483648
         while (r_num < (long)Integer.MIN_VALUE) {
            r_num /= 10;
            r_point++;
         }
      }
      return new FixedPoint((int)r_num,
                                 r_point);
   }
   // Œ菭_̈Z	subtraction
   static FixedPoint sub(FixedPoint a, FixedPoint b) {
      int pp = 0;
      if (a.point >= b.point) {
         b.setPoint(a.point); pp = a.point;
      } else {
         a.setPoint(b.point); pp = b.point;
      }
      return new FixedPoint((a.num - b.num), pp);
   }
   // Œ菭_̑Z	addition
   static FixedPoint add(FixedPoint a, FixedPoint b) {
      int pp = 0;
      if (a.point >= b.point) {
         b.setPoint(a.point); pp = a.point;
      } else {
         a.setPoint(b.point); pp = b.point;
      }
      return new FixedPoint((a.num + b.num), pp);
   }

   static FixedPoint Str2FixedPoint(String str) {
      int num   = 0;
      int point = 0;
      int sign  = 1;
      boolean fp = false;
      for (int i = 0; i < str.length(); i++) {
         if (fp == true) point -= 1;
         if (true == Character.isDigit(str.charAt(i))) {
            num *= 10;
            num += Character.digit(str.charAt(i), 10);
if (Debug) System.out.println(num + ":" + point);
         } else {
            if ('.' == str.charAt(i)) fp   = true;
            if ('-' == str.charAt(i)) sign = -1;
         }
      }
/*
      if (fp == false) {
         point *= 10;
         num   *= 10;
      }
 */
      FixedPoint result = new FixedPoint(sign * num, point);
//    result.setPoint(-4);    // _ʒu̕ύX
// if (Debug) System.out.println(result.getNum() + ":" + result.getPoint());
      return result;
   }
}
