import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

//tH[g({)
//copyright (c) Hidekazu Furukawa
public final class pinhole extends MIDlet implements CommandListener {
    /** This MIDlets Display object */
    private Display     display;    // Our display
    private pinholeForm form;
    /** The shutter Command */
    private Command shutterCommand = new Command("Shutter", Command.SCREEN, 1);
    /** The Reset   Command */
    private Command   resetCommand = new Command("Reset",   Command.SCREEN, 2);
    /** The Help    Command */
    private Command    helpCommand = new Command("Help",    Command.SCREEN, 3);
    /** The About   Command */
    private Command   aboutCommand = new Command("About",   Command.SCREEN, 4);
    /** The Exit    Command */
    private Command    exitCommand = new Command("Exit",    Command.SCREEN, 5);

    //RXgN^
    public pinhole(){
       display = Display.getDisplay(this);
       form = new pinholeForm();
       display.setCurrent(form);
       form.addCommand(shutterCommand);
       form.addCommand(  resetCommand);
       form.addCommand(   helpCommand);
       form.addCommand(  aboutCommand);
       form.addCommand(   exitCommand);
       form.setCommandListener(this);
    }

    //Av̊Jn
    public void startApp() {
    }

    //Av̈ꎞ~
    public void pauseApp() {
    }

    //Av̏I
    public void destroyApp(boolean unconditional) {
    }
   /**
    * Respond to a commands issued on any Screen.
    * @param c Command invoked
    * @param s Displayable on which the command was invoked
    */
   public void commandAction(Command c, Displayable s) {
      if (c == exitCommand) {
         destroyApp(true);
         notifyDestroyed();
      } else if (c == shutterCommand) {
         if (form.runStatus == false) {
            if (0 <= form.ExposureTime) form.reset();
            form.runStatus = true;         // stO
         } else {
            form.runStatus = false;         // stO
         }
         // Ԍvłm点
         form.click();
      } else if (c == resetCommand) {
         form.click();
         form.reset();
         form.runStatus = false;         // stO
      } else if (c ==  helpCommand) {
         form.click();
         Help.showHelp(display);
      } else if (c == aboutCommand) {
         form.click();
         About.showAbout(display);
      }
   }
}

