// import com.jblend.media.smd.*;
import java.util.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

//copyright (c) triring
final class pinholeForm extends Form implements Runnable, ItemStateListener {
//  implements CommandListener {
//  
//                                       ComponentListener, 
//                                     SoftKeyListener {

   String[] Fnum = { " 1.0", " 1.2", " 1.4", " 1.8",
                     " 2.0", " 2.5", " 2.8", " 3.5",
                     " 4.0", " 4.5", " 5.6", " 6.7",
                     " 8.0", " 9.5", "11.0", "13.0",
                     "16.0", "19.0", "22.0", "27.0",
                     "32.0"
                    };
   String[][] ShutterSpeed = {
        { "30    ", "30.0000000" },
        { "20    ", "20.0000000" },
        { "15    ", "15.0000000" },
        { "10    ", "10.0000000" },
        { " 8    ", " 8.0000000" },
        { " 6    ", " 6.0000000" },
        { " 4    ", " 4.0000000" },
        { " 3    ", " 3.0000000" },
        { " 2    ", " 2.0000000" },
        { " 1.5  ", " 1.5000000" },
        { " 1    ", " 1.0000000" },
        { " 0.7  ", " 0.7000000" },
        { "1/   2", " 0.5000000" },
        { "1/   3", " 0.3333333" },
        { "1/   4", " 0.2500000" },
        { "1/   6", " 0.1666667" },
        { "1/   8", " 0.1250000" },
        { "1/  10", " 0.1000000" },
        { "1/  15", " 0.0666667" },
        { "1/  20", " 0.0500000" },
        { "1/  30", " 0.0333333" },
        { "1/  45", " 0.0222222" },
        { "1/  60", " 0.0166667" },
        { "1/  90", " 0.0111111" },
        { "1/ 125", " 0.0080000" },
        { "1/ 180", " 0.0055556" },
        { "1/ 250", " 0.0040000" },
        { "1/ 350", " 0.0028571" },
        { "1/ 750", " 0.0013333" },
        { "1/1000", " 0.0010000" },
        { "1/2000", " 0.0005000" }
     };

   Thread   runner;  // Thread́CAvP[VI܂ŁC
                     // iɎsB
   long     ExposureTime = 0;
   boolean  runStatus = false;   // stO
final static int interval = 100;    // 100 mil. second
   // ̍ e|    Rg
   // a4       0.1  sec  ̒Ⴂ    440Hz
   // a5       2.0  sec  ̍    880Hz
   // pi       0.05 sec  PiƂ쉹

   // SMD Ǘclass
   static SmdThread stA4;
   static SmdThread stA5;
   static SmdThread stPI;

   FixedPoint  fpFocalLength        = new FixedPoint( 50,  0); // 50
   FixedPoint  fpDiameter           = new FixedPoint(  2, -1); // 0.2
   FixedPoint  fpExposureMeterFnum  = new FixedPoint( 80, -1); // 8.0
   FixedPoint  fpPinholeFnum        = new FixedPoint(250,  0); // 250
   FixedPoint  fpShutterSpeed       = new FixedPoint(  8, -3); // 0.008

   Gauge       gFocalLength;
   Gauge       gDiameter;
   StringItem  siPinholeFnum;
   Gauge       gExposureMeterFnum;
   Gauge       gShutterSpeed;
   TextField   tfExposureTime;

// StringItem siExposureTimeInv;
// TextField  tfShutterSpeed;
// StringItem siShutterSpeedInv;

   String lblTitle1            = new String("jEʐ^@");
   String lblTitle2            = new String("@IoԌvZ");
   String lblFocalLength       = new String("œ_(mm):");
   String lblDiameter          = new String("jEa(mm):");
   String lblPinholeFnum       = new String("jE@@f/l:");
   String lblExposureMeterFnum = new String("Iov@f/l");
   String lblShutterSpeed      = new String("Vb^[x:\n");
   String lblExposureTime      = new String("jEIo(sec)");

// Button CalcButton;

   //RXgN^
   public pinholeForm(){
      super("pinhole");
      setTitle(lblTitle1 + "\n" + lblTitle2);

      // SMD Ǘclass
      stA4 = new SmdThread("a4.smd");
      stA5 = new SmdThread("a5.smd");
      stPI = new SmdThread("pi.smd");

      stA4.start();
      stA5.start();
      stPI.start();

      runner = new Thread(this);
      runner.start();

//    tfFocalLength = new TextField(lblFocalLength, "50", 12, TextField.NUMERIC);
      gFocalLength = new Gauge(lblFocalLength + fpFocalLength.getDouble(0), true, 200, 50);
      append(gFocalLength);

      gDiameter = new Gauge(lblDiameter + fpDiameter.getDouble(1), true, 100, 20);
//    System.out.println(fpDiameter.getDouble(1));
      append(gDiameter);

      siPinholeFnum = new StringItem(lblPinholeFnum, 
                                      fpPinholeFnum.getDouble(2));
      append(siPinholeFnum);

      gExposureMeterFnum = new Gauge(lblExposureMeterFnum + Fnum[12], true, Fnum.length -1, 12);
      append(gExposureMeterFnum);

      gShutterSpeed = new Gauge(lblShutterSpeed + ShutterSpeed[24][0] + " sec", true, ShutterSpeed.length -1, 24);
      append(gShutterSpeed);

      tfExposureTime = new TextField(lblExposureTime, "7.812500", 12, TextField.ANY);
      append(tfExposureTime);
      setItemStateListener(this);
   }

/*
   FixedPoint calcPinholeFnum() {
      fpPinholeFnum = FixedPoint.div(fpFocalLength, fpDiameter);
      siPinholeFnum.setText(fpPinholeFnum.getDouble(1));
      return fpPinholeFnum;
   }
 */
   // IoԂ̌vZ
   FixedPoint calcExposureTime() {
      fpPinholeFnum = FixedPoint.div(fpFocalLength, fpDiameter);
      siPinholeFnum.setText(fpPinholeFnum.getDouble(1));
      FixedPoint a  = FixedPoint.mult(fpPinholeFnum, fpPinholeFnum);
      FixedPoint b  = FixedPoint.mult(fpExposureMeterFnum, fpExposureMeterFnum);
      FixedPoint mm = FixedPoint.div(a, b);
      FixedPoint tt = FixedPoint.Str2FixedPoint(
                                 ShutterSpeed[gShutterSpeed.getValue()][1]
                      );
      FixedPoint pt1 = FixedPoint.mult(tt, mm);
      tfExposureTime.setString(" " + pt1.getDouble(6));

      FixedPoint et = new FixedPoint(pt1.getNum(), pt1.getPoint() + 1);
/*
      System.out.println(pt1.getNum() + "," + pt1.getPoint());
      System.out.println(et.getNum() + "," + et.getPoint());
      System.out.println(et.getLong());
 */
      ExposureTime = et.getLong();

      return pt1;
   }

   // 
   public void reset() {
      calcExposureTime();
   }

   // NbN̍Đ
   public static void click() {
      if (null != stPI) stPI.playSMD(1);
   }


    /** Runnable interface. */
    public void run() {
       for (;;) {
          try {
             Thread.sleep(100);
          } catch (Exception e) {}
          if (runStatus == true) {
             ExposureTime--;
             if (ExposureTime == 30) stA4.playSMD(1); // ̒Ⴂ    440Hz
             if (ExposureTime == 20) stA4.playSMD(1); // ̒Ⴂ    440Hz
             if (ExposureTime == 10) stA4.playSMD(1); // ̒Ⴂ    440Hz
             if (ExposureTime <= 0) {
                runStatus = false;   // stO
                tfExposureTime.setString("0.0");
                stA5.playSMD(1); // ̍    880Hz
             } else {
                tfExposureTime.setString((ExposureTime / 10) + "." +
                                         (ExposureTime % 10) + " sec");
             }
          }
       }
    }

   /**
    * Reflect changes in the item states into the states.
    * @param item that to which some change occurred
    */
   public void itemStateChanged(Item item) {
      if (item == gFocalLength) {
         int l = gFocalLength.getValue();
         if (l == 0) l = 1;
         fpFocalLength = new FixedPoint(l, 0);
         gFocalLength.setLabel(lblFocalLength + fpFocalLength.getDouble(0));
         calcExposureTime();
      } else if (item == gDiameter) {
         int d = gDiameter.getValue();
         if (d == 0) d = 1;
         fpDiameter  = new FixedPoint(d, -2);
         gDiameter.setLabel(lblDiameter + fpDiameter.getDouble(2));
         calcExposureTime();
      } else if (item == gExposureMeterFnum) {
         gExposureMeterFnum.setLabel(lblExposureMeterFnum +
                                     Fnum[gExposureMeterFnum.getValue()]);
         fpExposureMeterFnum = FixedPoint.Str2FixedPoint(
                                  Fnum[gExposureMeterFnum.getValue()]
                               );
         System.out.println("gExposureMeterFnum");
         calcExposureTime();
      } else if (item == gShutterSpeed) {
         gShutterSpeed.setLabel(lblShutterSpeed +
                                   ShutterSpeed[gShutterSpeed.getValue()][0] +
                                   " sec"
                               );
      // System.out.println("gShutterSpeed");
         calcExposureTime();
      }
   }


}

